from funki.funk.test.all import f as test
from funki.directory.make import f as mkdir
from funki.directory.remove import f as rmdir
from funki.file.save_string import f as save
from funki.terminal import Terminal
from funki.system.git.commit_if_test_and_app_ok import f as commit_if_t_and_a
from funki.project.refactorisation.recommend import f as recommend_refactors
"""
from funki.git_manager import GitManager
from funki.refactor_recommender import RefactorRecommender
"""

def f(app=None, root='./src/funks', term=None):
  term = term or Terminal()
  test_ok = test(root, term)
  app_ok = app.run(silent=True)
  result = commit_if_t_and_a(test_ok, app_ok, lambda: 1, lambda: 0)
  # print(f'result: {result}')
  # rr_result = recommend_refactors()
  return result

_root = './temp_auto_commit'

_Π = {
  'convert_list_of_tuples_to_dict': '\n'.join([
    "from funki.funk.funk import Funk",
    "",
    "def _run(σ, x):",
    "  Δ = {k: 0 for (k, v) in x}",
    "  for (k, v) in x: Δ[k] = Δ[k] + v",
    "  return Δ",
    "",
    "funk = Funk(",
    "  enabled=True,",
    "  name='convert_list_of_tuples_to_dict',",
    "  description='',",
    "  io_value_pairs=[",
    "  (",
    "    {'x': [('a', 1), ('b', 2), ('a', 3), ('b', 4)]},",
    "    {'y': {'a': 4, 'b': 6}}",
    "  )",
    "  ],",
    "  run=_run",
    ")",
  ]),
  'get_last_date_of_month': '\n'.join([
    "from datetime import date",
    "from datetime import timedelta",
    "from funki.funk.funk import Funk",
    "",
    "def _run(σ, x):",
    "  δ = date(x['year'], x['month_number'], 27)",
    "  while δ.month <= x['month_number'] and δ.year <= x['year']:",
    "    δ_previous = δ",
    "    δ += timedelta(days=1)",
    "  return δ_previous",
    "",
    "funk = Funk(",
    "  name='get_last_date_of_month',",
    "  description='',",
    "  io_value_pairs=[",
    "    ({'x': {'year': 2016, 'month_number': 5}}, {'y': date(2016, 5, 31)}),",
    "    ({'x': {'year': 2017, 'month_number': 6}}, {'y': date(2017, 6, 30)}),",
    "    ({'x': {'year': 2020, 'month_number': 2}}, {'y': date(2020, 2, 29)}),",
    "    ({'x': {'year': 2021, 'month_number': 2}}, {'y': date(2021, 2, 28)}),",
    "    ({'x': {'year': 2021, 'month_number': 12}}, {'y': date(2021, 12, 31)}),",
    "  ],",
    "  run=_run",
    ")",
  ])
}

setup = lambda: [mkdir(_root), *[save(_root+'/'+k+'.py', _Π[k]) for k in _Π]]

tear_down = lambda: rmdir(_root)

class _App:
  def __init__(self): pass
  def run(self, silent=False): return True

def t():
  setup()
  _term = Terminal(mode='test')
  z = f(app=_App(), root=_root, term=_term)
  tear_down()
  return z == 1
